unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ToolWin, ComCtrls, Grids;

type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    ToolBar1: TToolBar;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses ComObj;

{$R *.dfm}

const
  xlContinuous=1;
  xlThin=2;

	xlTop = -4160;
	xlCenter = -4108;

var
  Excel:Variant;
  ExRow:integer;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Excel:=CreateOleObject('Excel.Application');
  Excel.Application.EnableEvents:=false;
  Excel.Workbooks.Add;
  Excel.Visible:=true;
  ExRow:=1;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i,j:integer;
  S:string;
begin
  Excel.ActiveWorkBook.WorkSheets[1].Range['A'+IntToStr(ExRow)+':G'+IntToStr(ExRow)].Merge;
  Excel.ActiveWorkBook.WorkSheets[1].Range['A'+IntToStr(ExRow)+':G'+IntToStr(ExRow)].Select;
  Excel.Selection.HorizontalAlignment:=xlCenter;
  Excel.ActiveWorkBook.WorkSheets[1].Cells[ExRow,1]:='     ';
  Inc(ExRow);
  for i:=0 to StringGrid1.RowCount-1 do
  begin
    for j:=0 to StringGrid1.ColCount-1 do
    begin
      S:=StringGrid1.Cells[j,i];
      Excel.ActiveWorkBook.WorkSheets[1].Cells[ExRow,j+1]:=S;
    end;
    Inc(ExRow);
  end;
  Inc(ExRow);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  i,j:integer;
  S:string;
  Row:Variant;
begin
  Excel.ActiveWorkBook.WorkSheets[1].Range['A'+IntToStr(ExRow)+':G'+IntToStr(ExRow)].Merge;
  Excel.ActiveWorkBook.WorkSheets[1].Range['A'+IntToStr(ExRow)+':G'+IntToStr(ExRow)].Select;
  Excel.Selection.HorizontalAlignment:=xlCenter;
  Excel.ActiveWorkBook.WorkSheets[1].Cells[ExRow,1]:='   ( )';
  Inc(ExRow);

  //  Variant  ...
  Row:=VarArrayCreate([0, StringGrid1.ColCount-1], varVariant);

  for i:=0 to StringGrid1.RowCount-1 do
  begin
    for j:=0 to StringGrid1.ColCount-1 do
    begin
      S:=StringGrid1.Cells[j,i];
      Row[j]:=S;
    end;
    Excel.ActiveWorkBook.WorkSheets[1].Range['A'+IntToStr(ExRow)+':E'+IntToStr(ExRow)].Value:=Row;
    Inc(ExRow);
  end;
  Inc(ExRow);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Excel.ActiveWorkBook.WorkSheets[1].Range['A'+IntToStr(ExRow-6)+':E'+IntToStr(ExRow-1)].Select;
  Excel.Selection.WrapText:=true;
  Excel.ActiveWorkBook.WorkSheets[1].Range['A'+IntToStr(ExRow-6)+':A'+IntToStr(ExRow-6)].Select;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  Excel.ActiveWorkBook.WorkSheets[1].Range['A'+IntToStr(ExRow-6)+':E'+IntToStr(ExRow-1)].Select;
  Excel.Selection.Borders.LineStyle:=xlContinuous;
  Excel.Selection.Borders.Weight:=xlThin;
  Excel.ActiveWorkBook.WorkSheets[1].Range['A'+IntToStr(ExRow-6)+':A'+IntToStr(ExRow-6)].Select;
end;

end.
